package org.hyperscala.html.tag

import org.hyperscala._
import css.StyleSheet
import html.HTMLTag
import org.hyperscala.html.attributes._
import org.hyperscala.html.constraints._

/**
 * NOTE: This file has been generated. Do not modify directly!
 * @author Matt Hicks <mhicks@hyperscala.org>
 */
class Option extends Textual with BodyChild with HTMLTag {
  lazy val xmlLabel = "option"

  def this(name: String = null,
           accessKey: java.lang.Character = null,
           clazz: List[String] = null,
           contentEditable: ContentEditable = null,
           contextMenu: String = null,
           dir: Direction = null,
           draggable: Draggable = null,
           dropZone: DropZone = null,
           hidden: java.lang.Boolean = null,
           id: String = null,
           lang: String = null,
           spellCheck: java.lang.Boolean = null,
           style: StyleSheet = null,
           tabIndex: java.lang.Integer = null,
           title: String = null,
           disabled: java.lang.Boolean = null,
           label: String = null,
           selected: java.lang.Boolean = null,
           value: String = null,
           content: String = null) = {
    this()
    up(this.name, name)
    up(this.accessKey, accessKey)
    up(this.clazz, clazz)
    up(this.contentEditable, contentEditable)
    up(this.contextMenu, contextMenu)
    up(this.dir, dir)
    up(this.draggable, draggable)
    up(this.dropZone, dropZone)
    up(this.hidden, hidden)
    up(this.id, id)
    up(this.lang, lang)
    up(this.spellCheck, spellCheck)
    up(this.style, style)
    up(this.tabIndex, tabIndex)
    up(this.title, title)
    up(this.disabled, disabled)
    up(this.label, label)
    up(this.selected, selected)
    up(this.value, value)
    up(this.content, content)
  }

  val disabled = PropertyAttribute[Boolean]("disabled", false)
  val label = PropertyAttribute[String]("label", null)
  val selected = PropertyAttribute[Boolean]("selected", false)
  val value = PropertyAttribute[String]("value", null)

  selected.onChange {
    parent match {
      case select: Select => {
        if (selected()) {
          if (!select.selected().contains(value())) {
            select.selected += value()      // Add the value to the selection if it isn't already there
          }
        } else {
          if (select.selected().contains(value())) {
            select.selected -= value()      // Remove the value from the selection if it is there
          }
        }
      }
      case _ => // Parent isn't a SELECT
    }
  }
}